Subject: Re: [PATCH bpf-next] libbpf: emit diff of mismatched public API, if any

From: Stanislav Fomichev <[email-masked]>
Date: Wed, 22 May 2019 11:00:55 -0700

On 05/22, Andrii Nakryiko wrote:
> On Wed, May 22, 2019 at 9:46 AM Stanislav Fomichev <[email-masked]> wrote:
> >
> > On 05/22, Alexei Starovoitov wrote:
> > > On 5/22/19 9:15 AM, Andrii Nakryiko wrote:
> > > > It's easy to have a mismatch of "intended to be public" vs really
> > > > exposed API functions. While Makefile does check for this mismatch, if
> > > > it actually occurs it's not trivial to determine which functions are
> > > > accidentally exposed. This patch dumps out a diff showing what's not
> > > > supposed to be exposed facilitating easier fixing.
> > > >
> > > > Signed-off-by: Andrii Nakryiko <[email-masked]>
> > > > ---
> > > >   tools/lib/bpf/.gitignore | 2 ++
> > > >   tools/lib/bpf/Makefile   | 8 ++++++++
> > > >   2 files changed, 10 insertions(+)
> > > >
> > > > diff --git a/tools/lib/bpf/.gitignore b/tools/lib/bpf/.gitignore
> > > > index d9e9dec04605..c7306e858e2e 100644
> > > > --- a/tools/lib/bpf/.gitignore
> > > > +++ b/tools/lib/bpf/.gitignore
> > > > @@ -3,3 +3,5 @@ libbpf.pc
> > > >   FEATURE-DUMP.libbpf
> > > >   test_libbpf
> > > >   libbpf.so.*
> > > > +libbpf_global_syms.tmp
> > > > +libbpf_versioned_syms.tmp
> > > > diff --git a/tools/lib/bpf/Makefile b/tools/lib/bpf/Makefile
> > > > index f91639bf5650..7e7d6d851713 100644
> > > > --- a/tools/lib/bpf/Makefile
> > > > +++ b/tools/lib/bpf/Makefile
> > > > @@ -204,6 +204,14 @@ check_abi: $(OUTPUT)libbpf.so
> > > >                  "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
> > > >                  "Please make sure all LIBBPF_API symbols are"       \
> > > >                  "versioned in $(VERSION_SCRIPT)." >&2;              \
> > > > +           readelf -s --wide $(OUTPUT)libbpf-in.o |                 \
> > > > +               awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $$8}'|   \
> > > > +               sort -u > $(OUTPUT)libbpf_global_syms.tmp;           \
> > > > +           readelf -s --wide $(OUTPUT)libbpf.so |                   \
> > > > +               grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |             \
> > > > +               sort -u > $(OUTPUT)libbpf_versioned_syms.tmp;        \
> > > > +           diff -u $(OUTPUT)libbpf_global_syms.tmp                  \
> > > > +                $(OUTPUT)libbpf_versioned_syms.tmp;                 \
> > > >             exit 1;                                                  \
> > >
> > > good idea.
> > > how about removing tmp files instead of adding them to .gitignore?
> > We should be able to do it without any temp files. At least in bash
> > one can do:
> >
> > diff -u <(readelf -s --wide ${OUTPUT}libbpf-in.o | \
> >           awk '/GLOBAL/ && /DEFAULT/ && !/UND/ {print $8}' | \
> >           sort -u) \
> >         <(readelf -s --wide ${OUTPUT}libbpf.so | \
> >           grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 | \
> >           sort -u)
> >
> > But might be complicated in the makefile :-/
> 
> that was my initial implementation, but it doesn't work in Makefile,
> as it's bash-specific
I guess you can wrap it in 'bash -c', but I'm not sure it's better
than the temp files at this point :)

diff --git a/tools/lib/bpf/Makefile b/tools/lib/bpf/Makefile
index f91639bf5650..a0005673dcd5 100644
--- a/tools/lib/bpf/Makefile
+++ b/tools/lib/bpf/Makefile
@@ -204,6 +204,13 @@ check_abi: $(OUTPUT)libbpf.so
                     "versioned symbols in $^ ($(VERSIONED_SYM_COUNT))." \
                     "Please make sure all LIBBPF_API symbols are"       \
                     "versioned in $(VERSION_SCRIPT)." >&2;              \
+               bash -c " \
+                    diff -u <(readelf -s --wide $(OUTPUT)libbpf-in.o |  \
+                              awk '/GLOBAL/ && /DEFAULT/ && !/UND/      \
+                              {print \$$8}' | sort -u)                  \
+                            <(readelf -s --wide $(OUTPUT)libbpf.so |    \
+                              grep -Eo '[^ ]+@LIBBPF_' | cut -d@ -f1 |  \
+                              sort -u);"                                \
                exit 1;                                                  \
        fi